import axios from "axios";
import cheerio, { load } from "cheerio";
import { JSDOM } from 'jsdom';
import { Proret } from "../config";
import { ytv } from "../lib/y2mate";
import { ErrorResponse } from "../interface/interface";

async function shortener(url) {
  return url;
}
interface Rusol {
  thumb: any;
  v_id: any;
  desc: string;
  nowm: any;
  author: {
    author: any;
    author_name: any;
    author_profile: any;
  };
  other: {
    link?: any[];
    wm?: any;
    audio?: {
      link: any;
      title: string;
    };
  };
}

export const downloads = {
  async FaceBook(url: string): Promise<any> {
    try {
      const config = {
        id: url,
        locale: "id",
      };
      const { data, status } = await axios("https://getmyfb.com/process", {
        method: "POST",
        data: new URLSearchParams(Object.entries(config)),
        headers: {
          "user-agent": "Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/105.0.0.0 Safari/537.36",
          cookie: "PHPSESSID=914a5et39uur28e84t9env0378; popCookie=1; prefetchAd_4301805=true",
        },
      });
      if (status === 200) {
        const $ = load(data),
          vid = [],
          thumb = $("div.container > div.results-item > div.results-item-image-wrapper").find("img").attr("src"),
          desc = $("div.container > div.results-item > div.results-item-text").text().trim();

        $("div.container > div.results-download > ul > li").each((u, i) => {
          vid.push({
            quality: $(i).text().trim().split('(')[0],
            link: $(i).find('a').attr('href')
          });
        });

        let hasil = {
          desc: desc,
          thumb: thumb,
          video: vid,
        };
        return Proret(hasil)
      }
    } catch (err) {
      console.log(err);
    };
  },
  async MusiCally(url: string): Promise<any | ErrorResponse> {
    try {
      let user_agent = "Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:108.0) Gecko/20100101 Firefox/108.0"
      const { data, status, headers } = await axios.get("https://musicaldown.com/id", {
        headers: {
          "user-agent": user_agent,
        },
      });
      if (status === 200) {
        const $ = load(data);
        const url_name = $("#link_url").attr("name");
        const token_name = $("#submit-form > div").find("div:nth-child(1) > input[type=hidden]:nth-child(2)").attr("name");
        const token_ = $("#submit-form > div").find("div:nth-child(1) > input[type=hidden]:nth-child(2)").attr("value");
        const verify = $("#submit-form > div").find("div:nth-child(1) > input[type=hidden]:nth-child(3)").attr("value");
        const _data = {
          [`${url_name}`]: url,
          [`${token_name}`]: token_,
          verify: verify,
        };
        const respon = await axios.request({
          url: "https://musicaldown.com/id/download",
          method: "post",
          data: new URLSearchParams(Object.entries(_data)),
          headers: {
            "user-agent": user_agent,
            cookie: headers["set-cookie"],
          },
        });
        const ch = load(respon.data);
        const resaudio = await axios.request({
          url: "https://musicaldown.com/id/mp3",
          method: "post",
          headers: {
            "user-agent": user_agent,
            cookie: headers["set-cookie"],
          },
        });
        let vdlk = ch("body > div.welcome.section > div > div:nth-child(2) > div.col.s12.l8 > a:nth-child(5)").attr("href");
        if (typeof vdlk === "undefined") return { developer: "@xorizn", mess: "Infalid link, no result found" };
        const hc = load(resaudio.data);
        const hasil_ = {
          user: ch("body > div.welcome.section > div > div:nth-child(2) > div.col.s12.l4.center-align > div.col.s12 > h2.white-text").find("b").text(),
          desk: ch("body > div.welcome.section > div > div:nth-child(2) > div.col.s12.l4.center-align > div.col.s12 > h2.white-text:nth-child(3)").text(),
          profile: ch("body > div.welcome.section > div > div:nth-child(2) > div.col.s12.l4.center-align > div.col.s12 > div.img-area > img").attr("src"),
          video: vdlk,
          audio: hc("body > div.welcome.section > div.container > div:nth-child(2) > div.col.s12.l4 > audio > source").attr("src"),
          video_original: ch("body > div.welcome.section > div > div:nth-child(2) > div.col.s12.l8 > a:nth-child(9)").attr("href"),
        }
        return Proret(hasil_);
      }
    } catch (err) {
      console.log(err)
    }
  },
  async PinterestVid(url: string): Promise<any | ErrorResponse> {
    try {
      let config = { url: url };
      const { data, status } = await axios("https://www.expertstool.com/download-pinterest-video/", {
        method: "POST",
        data: new URLSearchParams(Object.entries(config)),
        headers: {
          "user-agent": "Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:108.0) Gecko/20100101 Firefox/108.0",
        },
      });
      if (status === 200) {
        const $ = load(data);
        let link = $("div.col-md-8.col-md-offset-2 > video").attr("src");
        if (typeof link === "undefined") return { creator: "@xorizn", mess: `Link Not Found` };
        return Proret({ url: link });
      }
    } catch (err) {
      console.log(err)
    }
  },
  async SoundCloude(search: string): Promise<any | ErrorResponse> {
    try {
      const getToken = await axios.get("https://soundcloudmp3.org/", {
        headers: {
          "user-agent": "Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:108.0) Gecko/20100101 Firefox/108.0",
          cookie: "XSRF-TOKEN=eyJpdiI6ImsrUTZJTVQxbWwwSGZHWkFVem16SkE9PSIsInZhbHVlIjoiMFA0RFk1ZFE0dzI4emJ0VWZFZGVSSGxwd3U2NkhzK2g5XC9xekFtNE1kajdGaVJvUHZMdUJ6SUR6XC9qQm55NUtaZGVlU0llSE5TRmtGM2xKOGRnYUJQZz09IiwibWFjIjoiY2YxNjQxOWRiNDNkODlmYzQ4M2Q0ZTdlNTUxNmQ0MDVhNTFkMGI0MTVlNzZlY2NlMDNhYTBkODg2MzE4YTk5YyJ9; laravel_session=eyJpdiI6Im8zbUk1UkRSOHpDanBXVzJpdmRNZXc9PSIsInZhbHVlIjoiWlNTRnVYZVwvb21PRjJhaU81UFRKRDRIb0dOUWRPSjAxcGV1MEhYV1NnbTA4M0FvT2lJQmQrb3JDRzh4Y3UxTkdlNFwvSlhLSnF4TmZUTHRUUVBPNGNTQT09IiwibWFjIjoiMDQwZTFlNDNkYzFlOWNhOTVlM2E3NDNlM2M5N2MyNTkyMTQ1ZTQwNGYwNGQ2ZDlhYTY0MTE4Nzc0M2UzMGEwMCJ9",
        },
      });
      let _search = await axios.get(`https://soundcloud.com/search?q=${search}`);
      let $ = load(_search.data);
      let _datt = [];
      $("#app > noscript").each((u, i) => {
        _datt.push($(i).html());
      });
      let __$ = load(_datt[1]);
      let _link = [];
      __$("ul > li > h2 > a").each((i, u) => {
        if ($(u).attr("href").split("/").length === 3) {
          let linkk = $(u).attr("href");
          let jdi = `https://soundcloud.com${linkk}`;
          _link.push(jdi);
        }
      });
      const dom = new JSDOM(getToken.data).window.document;
      const a = dom.querySelector("#conversionForm").innerHTML;
      const token = /<input name="_token" type="hidden" value="(.*?)">/g.exec(a)[1];
      const config = {
        _token: token,
        lang: "en",
        url: _link[0],
        submit: "",
      };
      const { data, status } = await axios("https://soundcloudmp3.org/converter", {
        method: "POST",
        data: new URLSearchParams(Object.entries(config)),
        headers: {
          "user-agent": "Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:108.0) Gecko/20100101 Firefox/108.0",
          cookie: "XSRF-TOKEN=eyJpdiI6ImsrUTZJTVQxbWwwSGZHWkFVem16SkE9PSIsInZhbHVlIjoiMFA0RFk1ZFE0dzI4emJ0VWZFZGVSSGxwd3U2NkhzK2g5XC9xekFtNE1kajdGaVJvUHZMdUJ6SUR6XC9qQm55NUtaZGVlU0llSE5TRmtGM2xKOGRnYUJQZz09IiwibWFjIjoiY2YxNjQxOWRiNDNkODlmYzQ4M2Q0ZTdlNTUxNmQ0MDVhNTFkMGI0MTVlNzZlY2NlMDNhYTBkODg2MzE4YTk5YyJ9; laravel_session=eyJpdiI6Im8zbUk1UkRSOHpDanBXVzJpdmRNZXc9PSIsInZhbHVlIjoiWlNTRnVYZVwvb21PRjJhaU81UFRKRDRIb0dOUWRPSjAxcGV1MEhYV1NnbTA4M0FvT2lJQmQrb3JDRzh4Y3UxTkdlNFwvSlhLSnF4TmZUTHRUUVBPNGNTQT09IiwibWFjIjoiMDQwZTFlNDNkYzFlOWNhOTVlM2E3NDNlM2M5N2MyNTkyMTQ1ZTQwNGYwNGQ2ZDlhYTY0MTE4Nzc0M2UzMGEwMCJ9",
        },
      });
      if (status === 200) {
        const tot = [];
        const $ = load(data);
        const link = $("#ready-group > a").attr("href");
        if (typeof link === "undefined") return { developer: "@xorizn", mess: "no result found" };
        const img = $("#preview > div.info.clearfix > img").attr("src");
        $("#preview > div.info.clearfix > p").each(function (i, u) {
          tot.push($(u).text().replace(":", ": "));
        });
        const hasil = {
          title: tot[0],
          link: link ? link : "err",
          img: img ? img : "https://i.ibb.co/G7CrCwN/404.png",
          cap: `${tot.join("\n")}`,
        };
        return Proret(hasil);
      }
    } catch (err) {
      console.log(err)
    }
  },
  async TikTok(url: string): Promise<any | ErrorResponse> {
    try {
      let config = { query: url };
      const { data, status } = await axios("https://lovetik.com/api/ajax/search", {
        method: "POST",
        data: new URLSearchParams(Object.entries(config)),
      });
      if (data.mess) {
        return { developer: "@xorizn", mess: data.mess };
      } else if (status === 200) {
        let ar = [];
        let aud = [];
        let wm = [];
        let nowm = await shortener((data.play_url || "").replace("https", "http"));
        const rusol: Rusol = {
          thumb: data.cover,
          v_id: data.vid,
          desc: data.desc ? data.desc : "No desc",
          nowm: nowm,
          author: {
            author: data.author,
            author_name: data.author_name,
            author_profile: data.author_a,
          },
          other: {}
        };
        for (let i of data.links) {
          let link = await shortener((i.a || "").replace("https", "http"));
          if (i.t === "<b> MP4</b>") {
            ar.push(link);
            rusol.other.link = ar;
          } else if (i.s === "Watermarked") {
            rusol.other.wm = link;
          } else if (i.t === "<b>♪ MP3 Audio</b>") {
            aud.push({
              link: link,
              title: i.s,
            });
            rusol.other.audio = aud[0];
          }
        }
        return Proret(rusol);
      }
    } catch (err) {
      console.log(err)
    }
  },
  async Twitter(url: string): Promise<any | ErrorResponse> {
    try {
      let config = { URL: url };
      const { data, status } = await axios("https://twdown.net/download.php", {
        method: "POST",
        data: new URLSearchParams(Object.entries(config)),
        headers: {
          "user-agent": "Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/105.0.0.0 Safari/537.36",
          cookie: "PHPSESSID=914a5et39uur28e84t9env0378; popCookie=1; prefetchAd_4301805=true",
        },
      });
      if (status === 200) {
        const $ = load(data);
        let thumb = $("img.img-thumbnail").attr("src");
        let author = $('div[style="overflow-wrap: break-word;"].col-md-6 > h4').text();
        let desc = $('div[style="overflow-wrap: break-word;"].col-md-6 > p').text();
        let hasil = [];
        $("div.col-md-8.col-md-offset-2 > table > tbody > tr > td").each((a, b) => {
          let xor = $(b).find("a").attr("href");
          if (typeof xor === "undefined" || xor.startsWith("#")) {
          } else {
            hasil.push($(b).find("a").attr("href"));
          }
        }
        );
        const respose = {
          thumb: thumb,
          author: author,
          desc: desc,
          video: hasil[0],
          audio: `https://twdown.net/${hasil.pop()}`,
        };
        if (hasil.every((x) => x === undefined)) return { developer: "@xorizn", mess: "no result found" };
        return Proret(respose);
      }
    } catch (err) {
      console.log(err)
    }
  },
  async Ytv(url: string, server: string = "en406"): Promise<any> {
    try {
      const hasil = await ytv(url, server)
      return Proret(hasil);
    } catch (err) {
      console.log(err)
    }
  },
}