import axios from "axios";
import { load } from "cheerio";
import { Proret } from "../config";
import { ErrorResponse } from "../interface/interface";
interface Cc {
  audio?: string;
}
export const islam = {
  async Surah(no: number): Promise<any> {
    try {
      const { data } = await axios.get('https://kalam.sindonews.com/surah/' + no + '/al-fatihah')
      const $ = load(data)
      const result = [];
      const ar = [];
      const id = [];
      const lt = [];
      const cc: Cc = {};
      $('div.breadcrumb-new > ul > li:nth-child(5)').each(function (c, d) {
        cc.audio = $(d).find('a').attr('href').replace('surah', 'audioframe')
      })
      $('div.ayat-arab').each(function (a, b) {
        ar.push($(b).text())
      })
      $('li > div.ayat-text').each(function (e, f) {
        id.push($(f).text().replace(',', '').trim())
      })
      $('div.ayat-latin').each(function (g, h) {
        lt.push($(h).text().trim())
      })
      for (let i = 0; i < ar.length; i++) {
        result.push({
          arab: ar[i],
          indo: id[i],
          latin: lt[i],
        })
      }
      return Proret({ audio: cc.audio, surah: result })
    } catch(err) {
      console.error(err)
    }
  },
  async JadwalSholat(no: number): Promise<any> {
    try {
      const { data } = await axios.get('https://kalam.sindonews.com/jadwalsholat/' + no)
      const $ = load(data)
      const result = [];
      $('div.imsakiyah-content > table > tbody > tr').each(function (a, b) {
        result.push({
          tanggal: $(b).find('td:nth-child(1)').text(),
          imsak: $(b).find('td:nth-child(2)').text(),
          subuh: $(b).find('td:nth-child(3)').text(),
          zuhur: $(b).find('td:nth-child(4)').text(),
          ashar: $(b).find('td:nth-child(5)').text(),
          maghrib: $(b).find('td:nth-child(6)').text(),
          isya: $(b).find('td:nth-child(7)').text()
        })
      })
      return Proret(result)
    } catch(err) {
      console.error(err)
    }
  }

}