import axios from "axios";
import { ErrorResponse } from "../interface/interface";
import { Proret } from "../config";

let anya = { headers: { accept: '*/*', 'cookie': '_ga=GA1.2.1207987969.1680840450; __gads=ID=b26fd0857b3cff25-22ccef1502df0050:T=1680840450:RT=1680840450:S=ALNI_MaDqL-T5KCdhDZoTOiXpOvdcwJBdA; _gid=GA1.2.866837131.1681305528; __gpi=UID=00000bedb580261c:T=1680840450:RT=1681378876:S=ALNI_MacS9h_essTbZighLSVsRkvI1pm8A; ab_tests=%7B%7D; _gat=1', 'user-agent': 'Mozilla/5.0 (Windows NT 10.0; Win64; x64; rv:109.0) Gecko/20100101 Firefox/111.0' } }

async function StoryIG(user: string): Promise<any> {
  try {
    let { data, status } = await axios.get('https://storiesig.me/api/profile/stories?username=' + user, anya)
    let arr = [];
    for (let i of data) {
      if (i.id) {
        if (i.type === 'video') {
          arr.push({ url: i.url, type: i.type });
        } else {
          arr.push({
            url: i.url,
            url_original: i.originalUrl,
            type: i.type
          });
        };
      };
    };
    return arr
  } catch(err) {
    return { mess: err.toString() }
  }
}

interface Repos {
  repos?: any[]
}

export const stalk = {
  async instagram(type: string, user: string): Promise<any | ErrorResponse> {
    try {
      let tipes = ['profile', 'story', 'post', 'highlights', 'cash'];
      if (!tipes.includes(type)) return { developer: '@xorizn', mess: type + ' instagram not found' }
      if (type === 'profile') {
        var { data } = await axios.get('https://storiesig.me/api/profile/info?username=' + user, anya)
      } else if (type === 'story') {
        var data = await StoryIG(user)
        if (data.mess) return { developer: 'xorizn', mess: data.mess }
      } else if (type === 'post') {
        var { data } = await axios.get('https://storiesig.me/api/profile/publications?username=' + user, anya)
      } else if (type === 'highlights') {
        var { data } = await axios.get('https://storiesig.me/api/profile/highlights?username=' + user, anya)
      } else if (type === 'cash') {
        var { data } = await axios.get('https://storiesig.me/api/profile/cash?username=' + user, anya)
      }
      return Proret(data)
    } catch(err) {
      return { developer: 'xorizn', mess: err.toString() }
    }
  },
  async Github(user: string): Promise<any | ErrorResponse> {
    try {
      const { data, status } = await axios.get(`https://api.github.com/users/${user}`);
      if (data.message) return { developer: '@xorizn', mess: data.message }
      const { login, id, node_id, avatar_url, gravatar_id, url, html_url, followers_url, following_url, gists_url, starred_url, subscriptions_url, organizations_url, repos_url, events_url, received_events_url, type, site_admin, name, company, blog, location, email, hireable, bio, twitter_username, public_repos, public_gists, followers, following, created_at, updated_at, } = data;
      var hasil = {
        user: {
          login: login,
          id: id,
          node_id: node_id,
          avatar_url: avatar_url,
          gravatar_id: gravatar_id,
          url: url,
          html_url: html_url,
          followers_url: followers_url,
          following_url: following_url,
          gists_url: gists_url,
          starred_url: starred_url,
          subscriptions_url: subscriptions_url,
          organizations_url: organizations_url,
          repos_url: repos_url,
          events_url: events_url,
          received_events_url: received_events_url,
          type: type,
          site_admin: site_admin,
          name: name,
          company: company,
          blog: blog,
          location: location,
          email: email,
          hireable: hireable,
          bio: bio,
          twitter_username: twitter_username,
          public_repos: public_repos,
          public_gists: public_gists,
          followers: followers,
          following: following,
          created_at: created_at,
          updated_at: updated_at
        }
      };
      return Proret(hasil)
    } catch (err) {
      return { developer: 'xorizn', mess: err.toString() }
    }
  },
  async GithubRepo(user: string): Promise<any | ErrorResponse> {
    try {
      const { data, status } = await axios.get(`https://api.github.com/users/${user}`);
      if (data.message) return { developer: '@xorizn', mess: data.message };
      let repos = await axios.get(data.repos_url);
      var hasil: Repos = {}
      if (!repos.data) {
        hasil.repos = []
      }
      hasil.repos = repos.data
      return Proret(hasil)
    } catch (err) {
      return { developer: 'xorizn', mess: err.toString() }
    }
  }
}